<template>
  <div>
    <h1>{{ loading }}</h1>
    <v-btn v-on:click="goHome">Go Home</v-btn>
    <v-btn v-on:click="logout">Logout</v-btn>
    <v-btn v-on:click="addContact">Add new contact</v-btn>
    <ul>
      <li v-for="a of subjects" v-bind:key="a.code">
        {{ a.code }} - {{ a.name }}
      </li>
    </ul>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import gql from 'graphql-tag'

const ALL_SUBJECT = gql`
  query ALL_SUBJECT {
    subjects {
      code
      name
    }
  }
`
const ADD_CONTACT = gql`
  mutation AddContact($input: NewContactInput!) {
    addContact(newContactData: $input) {
      message
    }
  }
`

export default Vue.extend({
  data() {
    return {
      subjects: [],
      contacts: [],
      loading: false,
    }
  },
  head: {
    title: 'contact this is',
  },
  layout: 'plain',
  methods: {
    goHome(): void {
      this.$router.push('/')
    },

    logout(): void {
      this.$auth.logout()
    },

    addContact(): void {
      this.$apollo.mutate({
        mutation: ADD_CONTACT,
        variables: {
          input: {
            subject: 1,
            message: 'from nuxtjs',
          },
        },
      })
    },
  },
  async mounted() {
    const res = await this.$apollo.query({
      query: ALL_SUBJECT,
    })
    this.loading = res.loading
    const { subjects } = res.data
    this.subjects = subjects
  },
})
</script>